/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.21 from the
 * contents of SO3.xs. Do not edit this file, edit SO3.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "SO3.xs"
#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#ifdef __cplusplus
}
#endif

#include <math.h>
#include <stdio.h>

#define TF_DEBUG

typedef double *Math__SO3;

static char* croak_turn="Math::SO3::turn: Use as in: $rotation->turn(\"xr\" => 120, \"zr\" => 30)";

static char* croak_combine="Math::SO3::combine: Use as in: $rotation->combine($rotation_after)";

static char* croak_translate="Math::SO3::translate: Use as in: $rotation->translate_vectors($vec1, $vec2, @more_vecs)";

static char* croak_inv_translate="Math::SO3::translate: Use as in: $rotation->inv_translate_vectors($vec1, $vec2, @more_vecs)";

static char* croak_turning_angle_and_dir="Math::SO3::turning_angle_and_dir: Use as in: ($angle, $dir)=$rotation->turning_angle_and_dir(\"degrees\")";

static char* croak_euler_angles_zxz="Math::SO3::euler_angles_zxz: Use as in: ($phi, $theta, $psi)=$rotation->euler_angles_zxz(\"degrees\")";

static char* croak_turn_round_axis="Math::SO3::turn_round_axis: Use as in: $rotation->turn_round_axis(<axis>, <angle>, \"degrees\")";

static char* croak_invert="Math::SO3::invert: Use as in: $rotation->invert()";



static inline double my_acos(double x)
{
 if(x>1)return 0;
 if(x<-1)return M_PI;
 return acos(x);
}


static inline void do_turn(Math__SO3 so3, int axis, double angle)
{
  int i;
  double inv_norm, co, si, v1, v2, sprod;

  co=cos(angle);
  si=sin(angle);

  if(axis==0) /* x rotation */
    {
      /* The matrix M can map space coordinates to body coordinates via

            v' = M v

         So, if we turn the body round the body(!) x-axis, 
         we have to left-multiply M by

         (    1            0            0       )
         (    0            cos phi      sin phi )
         (    0           -sin phi      cos phi )

         Reason: general form should be obvious; the only question is 
         "where to place the minus sign". We have a 
         old-body-coords->new-body-coords transformation here, 
         therefore have to multiply v' = M v from the left with a matrix.

         When we rotate round x, starting from identity, the body vector with
         only z-coordinate=1 (0 0 1)^T will then have (expressed in 
         rotated-body components) a positive y component. That 
         determines sign. (y coord vector will have a negative z 
         component when expressed in new coords.)

         Now, how to do it: we may accept a bit "numeric drift", 
         but we can not accept our vectors getting nonorthogonal.
         Therefore, we turn and normalize and orthogonalize (Gram-Schmidt)
         x and y columns, and compute (without normalizing) 
         z as cross-product. We needn't normalize z,
         since the error will be small as x and y just have been normalized,
         and this error won't build up, since as a principle,
         we first normalize vectors when we add other rotations.

         Everything clear?
       */

      /* rotate and normalize "x" column */
      /* so3[0*3+0] remains unchanged */

      v1=so3[1*3+0];
      v2=so3[2*3+0];

      so3[1*3+0]=co*v1+si*v2;
      so3[2*3+0]=-si*v1+co*v2;
	
      inv_norm=1.0/sqrt( so3[0*3+0]*so3[0*3+0]
		        +so3[1*3+0]*so3[1*3+0]
		        +so3[2*3+0]*so3[2*3+0]);
      so3[0*3+0]*=inv_norm;
      so3[1*3+0]*=inv_norm;
      so3[2*3+0]*=inv_norm;

      /* rotate y column */

      /* so3[0*3+1] remains unchanged */

      v1=so3[1*3+1];
      v2=so3[2*3+1];

      so3[1*3+1]=co*v1+si*v2;
      so3[2*3+1]=-si*v1+co*v2;

      /* gram-schmidt orthogonalize y: y = y -(x*y)x */

      sprod= so3[0*3+0]*so3[0*3+1]
	    +so3[1*3+0]*so3[1*3+1]
	    +so3[2*3+0]*so3[2*3+1];

      so3[0*3+1]-=sprod*so3[0*3+0];
      so3[1*3+1]-=sprod*so3[1*3+0];
      so3[2*3+1]-=sprod*so3[2*3+0];

      /* normalize y */

      inv_norm=1.0/sqrt( so3[0*3+1]*so3[0*3+1]
		        +so3[1*3+1]*so3[1*3+1]
		        +so3[2*3+1]*so3[2*3+1]);
      so3[0*3+1]*=inv_norm;
      so3[1*3+1]*=inv_norm;
      so3[2*3+1]*=inv_norm;

      /* Z = X x Y */
      so3[0*3+2]=so3[1*3+0]*so3[2*3+1]-so3[2*3+0]*so3[1*3+1];
      so3[1*3+2]=so3[2*3+0]*so3[0*3+1]-so3[0*3+0]*so3[2*3+1];
      so3[2*3+2]=so3[0*3+0]*so3[1*3+1]-so3[1*3+0]*so3[0*3+1];
    }
  else if(axis==1) /* y rotation; simply do a cyclic change in code above. */
    {

      /* rotate and normalize "y" column */
      /* so3[1*3+1] remains unchanged */

      v1=so3[2*3+1];
      v2=so3[0*3+1];

      so3[2*3+1]=co*v1+si*v2;
      so3[0*3+1]=-si*v1+co*v2;

      inv_norm=1.0/sqrt( so3[1*3+1]*so3[1*3+1]
		        +so3[2*3+1]*so3[2*3+1]
		        +so3[0*3+1]*so3[0*3+1]);
      so3[1*3+1]*=inv_norm;
      so3[2*3+1]*=inv_norm;
      so3[0*3+1]*=inv_norm;

      /* rotate z column */

      /* so3[1*3+2] remains unchanged */

      v1=so3[2*3+2];
      v2=so3[0*3+2];

      so3[2*3+2]=co*v1+si*v2;
      so3[0*3+2]=-si*v1+co*v2;

      /* gram-schmidt orthogonalize z: z = z -(y*z)y */

      sprod= so3[1*3+1]*so3[1*3+2]
	    +so3[2*3+1]*so3[2*3+2]
	    +so3[0*3+1]*so3[0*3+2];

      so3[1*3+2]-=sprod*so3[1*3+1];
      so3[2*3+2]-=sprod*so3[2*3+1];
      so3[0*3+2]-=sprod*so3[0*3+1];

      /* normalize z */

      inv_norm=1.0/sqrt( so3[1*3+2]*so3[1*3+2]
		        +so3[2*3+2]*so3[2*3+2]
		        +so3[0*3+2]*so3[0*3+2]);
      so3[1*3+2]*=inv_norm;
      so3[2*3+2]*=inv_norm;
      so3[0*3+2]*=inv_norm;

      /* X = Y x Z */
      so3[1*3+0]=so3[2*3+1]*so3[0*3+2]-so3[0*3+1]*so3[2*3+2];
      so3[2*3+0]=so3[0*3+1]*so3[1*3+2]-so3[1*3+1]*so3[0*3+2];
      so3[0*3+0]=so3[1*3+1]*so3[2*3+2]-so3[2*3+1]*so3[1*3+2];
    }
  else /* z rotation */
    {
      /* rotate and normalize "z" column */
      /* so3[2*3+2] remains unchanged */

      v1=so3[0*3+2];
      v2=so3[1*3+2];

      so3[0*3+2]=co*v1+si*v2;
      so3[1*3+2]=-si*v1+co*v2;

      /* normalize z */
      inv_norm=1.0/sqrt( so3[2*3+2]*so3[2*3+2]
		        +so3[0*3+2]*so3[0*3+2]
		        +so3[1*3+2]*so3[1*3+2]);
      so3[2*3+2]*=inv_norm;
      so3[0*3+2]*=inv_norm;
      so3[1*3+2]*=inv_norm;

      /* rotate x column */

      /* so3[2*3+0] remains unchanged */

      v1=so3[0*3+0];
      v2=so3[1*3+0];

      so3[0*3+0]=co*v1+si*v2;
      so3[1*3+0]=-si*v1+co*v2;

      /* gram-schmidt orthogonalize x: x = x -(z*x)z */

      sprod= so3[2*3+2]*so3[2*3+0]
	    +so3[0*3+2]*so3[0*3+0]
	    +so3[1*3+2]*so3[1*3+0];

      so3[2*3+0]-=sprod*so3[2*3+2];
      so3[0*3+0]-=sprod*so3[0*3+2];
      so3[1*3+0]-=sprod*so3[1*3+2];

      /* normalize x */

      inv_norm=1.0/sqrt( so3[2*3+0]*so3[2*3+0]
		        +so3[0*3+0]*so3[0*3+0]
		        +so3[1*3+0]*so3[1*3+0]);
      so3[2*3+0]*=inv_norm;
      so3[0*3+0]*=inv_norm;
      so3[1*3+0]*=inv_norm;

      /* Y = Z x X */
      so3[2*3+1]=so3[0*3+2]*so3[1*3+0]-so3[1*3+2]*so3[0*3+0];
      so3[0*3+1]=so3[1*3+2]*so3[2*3+0]-so3[2*3+2]*so3[1*3+0];
      so3[1*3+1]=so3[2*3+2]*so3[0*3+0]-so3[0*3+2]*so3[2*3+0];
     }
}

#ifdef TF_DEBUG

/* just the same thing, but more primitive, and without all the
   normalization stuff. */

static inline void do_turn_debug(Math__SO3 so3, int axis, double angle)
{
  int i;
  double inv_norm, co, si, v1, v2, sprod, old_mx[9];

  co=cos(angle);
  si=sin(angle);

  if(axis==0)			/* x rotation */
    {
      so3[1*3+0]= co*old_mx[1*3+0]+si*old_mx[2*3+0];
      so3[2*3+0]=-si*old_mx[1*3+0]+co*old_mx[2*3+0];
      so3[1*3+1]= co*old_mx[1*3+1]+si*old_mx[2*3+1];
      so3[2*3+1]=-si*old_mx[1*3+1]+co*old_mx[2*3+1];
      so3[1*3+2]= co*old_mx[1*3+2]+si*old_mx[2*3+2];
      so3[2*3+2]=-si*old_mx[1*3+2]+co*old_mx[2*3+2];
    }
  else if(axis==1)		/* y rotation */
    {
      so3[2*3+1]= co*old_mx[2*3+1]+si*old_mx[0*3+1];
      so3[0*3+1]=-si*old_mx[2*3+1]+co*old_mx[0*3+1];
      so3[2*3+2]= co*old_mx[2*3+2]+si*old_mx[0*3+2];
      so3[0*3+2]=-si*old_mx[2*3+2]+co*old_mx[0*3+2];
      so3[2*3+0]= co*old_mx[2*3+0]+si*old_mx[0*3+0];
      so3[0*3+0]=-si*old_mx[2*3+0]+co*old_mx[0*3+0];
    }
  else				/* z rotation */
    {
      so3[0*3+2]= co*old_mx[0*3+2]+si*old_mx[1*3+2];
      so3[1*3+2]=-si*old_mx[0*3+2]+co*old_mx[1*3+2];
      so3[0*3+0]= co*old_mx[0*3+0]+si*old_mx[1*3+0];
      so3[1*3+0]=-si*old_mx[0*3+0]+co*old_mx[1*3+0];
      so3[0*3+1]= co*old_mx[0*3+1]+si*old_mx[1*3+1];
      so3[1*3+1]=-si*old_mx[0*3+1]+co*old_mx[1*3+1];
    }
}
#endif


#line 300 "SO3.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 352 "SO3.c"

XS(XS_Math__SO3_invert); /* prototype to pass -Wmissing-prototypes */
XS(XS_Math__SO3_invert)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 296 "SO3.xs"
	if(   items<1 
           || (items&1)==0
           || SvTYPE(SvRV(ST(0)))!=SVt_PVMG)

	{
		croak(croak_invert);
	}
	else
	{
		Math__SO3 so3;
		double x;

		so3=(Math__SO3)SvPV(SvRV(ST(0)), PL_na);

		x=so3[0*3+1];so3[0*3+1]=so3[1*3+0];so3[1*3+0]=x;
		x=so3[0*3+2];so3[0*3+2]=so3[2*3+0];so3[2*3+0]=x;
		x=so3[1*3+2];so3[1*3+2]=so3[2*3+1];so3[2*3+1]=x;
	}
#line 383 "SO3.c"
    }
    XSRETURN(1);
}


XS(XS_Math__SO3_turn); /* prototype to pass -Wmissing-prototypes */
XS(XS_Math__SO3_turn)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 319 "SO3.xs"
	if(   items<1 
           || (items&1)==0
           || SvTYPE(SvRV(ST(0)))!=SVt_PVMG)
	{
	croak(croak_turn);
	}
	else
	{
		int i, axis;
		char *axis_str;
		double angle;
		Math__SO3 so3;

		so3=(Math__SO3)(SvPV(SvRV(ST(0)), PL_na));

		for(i=1;i<items;i+=2)
		{
		  axis_str=(char *)SvPV(ST(i), PL_na); /* XXX PL_na in perl5.005! */
		  if(axis_str[0]=='x')
		    {
		      axis=0;
		    }
		  else if(axis_str[0]=='y')
		    {
		      axis=1;
		    }
		  else if(axis_str[0]=='z')
		    {
		      axis=2;
		    }
		  else
		    {	
		      croak(croak_turn);
		    }

		  angle=SvNV(ST(1+i));

		  if(axis_str[1]=='d')
		    {
		      angle*=M_PI/180;
		    }
		  else if(axis_str[1]!=0 && axis_str[1]!='r')
		    {
		      croak(croak_turn);
		    }

		  do_turn(so3, axis, angle);
		}
	}
#line 449 "SO3.c"
    }
    XSRETURN(1);
}


XS(XS_Math__SO3_combine); /* prototype to pass -Wmissing-prototypes */
XS(XS_Math__SO3_combine)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 374 "SO3.xs"
	if(   items!=2 
           || SvTYPE(SvRV(ST(0)))!=SVt_PVMG
           || SvTYPE(SvRV(ST(1)))!=SVt_PVMG)

	{
	  croak(croak_combine);
	}
	else
	{
	 /* column 1 and 2 are computed as matrix product, 
            2 is orthogonalized, 3 is cross-product. */

		int i;
		Math__SO3 rot_b, rot_a;
		double inv_norm, sprod, buffer[9];

		rot_b=(Math__SO3)(SvPV(SvRV(ST(0)), PL_na));
		rot_a=(Math__SO3)(SvPV(SvRV(ST(1)), PL_na));

		for(i=0;i<9;i++)buffer[i]=rot_b[i];

		rot_b[0*3+0]= rot_a[0*3+0]*buffer[0*3+0]
                             +rot_a[0*3+1]*buffer[1*3+0]
                             +rot_a[0*3+2]*buffer[2*3+0];

		rot_b[1*3+0]= rot_a[1*3+0]*buffer[0*3+0]
                             +rot_a[1*3+1]*buffer[1*3+0]
                             +rot_a[1*3+2]*buffer[2*3+0];

		rot_b[2*3+0]= rot_a[2*3+0]*buffer[0*3+0]
                             +rot_a[2*3+1]*buffer[1*3+0]
                             +rot_a[2*3+2]*buffer[2*3+0];

		inv_norm=1.0/sqrt( rot_b[0*3+0]*rot_b[0*3+0]
                                  +rot_b[1*3+0]*rot_b[1*3+0]
                                  +rot_b[2*3+0]*rot_b[2*3+0]);

		rot_b[0*3+0]*=inv_norm;
		rot_b[1*3+0]*=inv_norm;
		rot_b[2*3+0]*=inv_norm;

		rot_b[0*3+1]= rot_a[0*3+0]*buffer[0*3+1]
                             +rot_a[0*3+1]*buffer[1*3+1]
                             +rot_a[0*3+2]*buffer[2*3+1];

		rot_b[1*3+1]= rot_a[1*3+0]*buffer[0*3+1]
                             +rot_a[1*3+1]*buffer[1*3+1]
                             +rot_a[1*3+2]*buffer[2*3+1];

		rot_b[2*3+1]= rot_a[2*3+0]*buffer[0*3+1]
                             +rot_a[2*3+1]*buffer[1*3+1]
                             +rot_a[2*3+2]*buffer[2*3+1];

		sprod= rot_b[0*3+0]*rot_b[0*3+1]
                      +rot_b[1*3+0]*rot_b[1*3+1]
		      +rot_b[2*3+0]*rot_b[2*3+1];

		rot_b[0*3+1]-=sprod*rot_b[0*3+0];
		rot_b[1*3+1]-=sprod*rot_b[1*3+0];
		rot_b[2*3+1]-=sprod*rot_b[2*3+0];

		rot_b[0*3+2]=rot_b[1*3+0]*rot_b[2*3+1]-rot_b[2*3+0]*rot_b[1*3+1];
		rot_b[1*3+2]=rot_b[2*3+0]*rot_b[0*3+1]-rot_b[0*3+0]*rot_b[2*3+1];
		rot_b[2*3+2]=rot_b[0*3+0]*rot_b[1*3+1]-rot_b[1*3+0]*rot_b[0*3+1];
	}
#line 531 "SO3.c"
    }
    XSRETURN(1);
}


XS(XS_Math__SO3_turn_round_axis); /* prototype to pass -Wmissing-prototypes */
XS(XS_Math__SO3_turn_round_axis)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 461 "SO3.xs"
	if((items!=3 && items!=4)
           || SvTYPE(SvRV(ST(0)))!=SVt_PVMG
           || (!(SvPOK(ST(1)))))
	{
	  croak(croak_turn_round_axis);
	}
	else
	{
	  double *so3, *axis, angle, co, si;
	  double r_base[3], r_sin[3];
          double e_r[3], e_n[3], inv_len, sprod, norm;

	  so3=(double *)SvPV(SvRV(ST(0)), PL_na);
	  axis=(double *)SvPV(ST(1), PL_na);

	  angle=-SvNV(ST(2));

	  if(items==4)
	  {
             char *angle_spec;

	     angle_spec=(char *)SvPV(ST(3), PL_na);
             if(angle_spec[0]=='d')
               {
                angle*=M_PI/180;
	       }
             else if(angle_spec[0]!='r' && angle_spec[0]!=0)
	       {
                croak(croak_turn_round_axis);
               }
          }

          co=cos(angle);
	  si=sin(angle);

          inv_len=sqrt( axis[0]*axis[0]
                       +axis[1]*axis[1]
                       +axis[2]*axis[2]);

	  if(inv_len==0)
          {
           croak("Math::SO3::turn_round_axis: axis is null vector!");
          }

	  inv_len=1/inv_len;

          /* This algorithm deals with body coordinates. Therefore, 
             we have to translate the coordinates of the axis to
             body coordinates first. 
          */
          e_n[0]=inv_len*(axis[0]*so3[0*3+0]+axis[1]*so3[0*3+1]+axis[2]*so3[0*3+2]);
          e_n[1]=inv_len*(axis[0]*so3[1*3+0]+axis[1]*so3[1*3+1]+axis[2]*so3[1*3+2]);
          e_n[2]=inv_len*(axis[0]*so3[2*3+0]+axis[1]*so3[2*3+1]+axis[2]*so3[2*3+2]);


          /* 
             Now, turn every column vector. 
             They represent space-base in body coordinates.
           */

          inv_len=sqrt( so3[0*3+0]*so3[0*3+0]
                       +so3[1*3+0]*so3[1*3+0]
                       +so3[2*3+0]*so3[2*3+0]);

	  if(inv_len!=0)inv_len=1/inv_len;

          e_r[0]=so3[0*3+0]*inv_len;
          e_r[1]=so3[1*3+0]*inv_len;
          e_r[2]=so3[2*3+0]*inv_len;

          sprod=e_r[0]*e_n[0]+e_r[1]*e_n[1]+e_r[2]*e_n[2];

          r_base[0]=e_n[0]*sprod;
          r_base[1]=e_n[1]*sprod;
          r_base[2]=e_n[2]*sprod;

	  r_sin[0]=e_n[1]*e_r[2]-e_n[2]*e_r[1];
	  r_sin[1]=e_n[2]*e_r[0]-e_n[0]*e_r[2];
	  r_sin[2]=e_n[0]*e_r[1]-e_n[1]*e_r[0];

	  so3[0*3+0]=co*so3[0*3+0]+(1-co)*r_base[0]+si*r_sin[0];
	  so3[1*3+0]=co*so3[1*3+0]+(1-co)*r_base[1]+si*r_sin[1];
	  so3[2*3+0]=co*so3[2*3+0]+(1-co)*r_base[2]+si*r_sin[2];


          inv_len=sqrt( so3[0*3+1]*so3[0*3+1]
                       +so3[1*3+1]*so3[1*3+1]
                       +so3[2*3+1]*so3[2*3+1]);

	  if(inv_len!=0)inv_len=1/inv_len;

          e_r[0]=so3[0*3+1]*inv_len;
          e_r[1]=so3[1*3+1]*inv_len;
          e_r[2]=so3[2*3+1]*inv_len;

          sprod=e_r[0]*e_n[0]+e_r[1]*e_n[1]+e_r[2]*e_n[2];

          r_base[0]=e_n[0]*sprod;
          r_base[1]=e_n[1]*sprod;
          r_base[2]=e_n[2]*sprod;

	  r_sin[0]=e_n[1]*e_r[2]-e_n[2]*e_r[1];
	  r_sin[1]=e_n[2]*e_r[0]-e_n[0]*e_r[2];
	  r_sin[2]=e_n[0]*e_r[1]-e_n[1]*e_r[0];

	  so3[0*3+1]=co*so3[0*3+1]+(1-co)*r_base[0]+si*r_sin[0];
	  so3[1*3+1]=co*so3[1*3+1]+(1-co)*r_base[1]+si*r_sin[1];
	  so3[2*3+1]=co*so3[2*3+1]+(1-co)*r_base[2]+si*r_sin[2];


          inv_len=sqrt( so3[0*3+2]*so3[0*3+2]
                       +so3[1*3+2]*so3[1*3+2]
                       +so3[2*3+2]*so3[2*3+2]);

	  if(inv_len!=0)inv_len=1/inv_len;

          e_r[0]=so3[0*3+2]*inv_len;
          e_r[1]=so3[1*3+2]*inv_len;
          e_r[2]=so3[2*3+2]*inv_len;

          sprod=e_r[0]*e_n[0]+e_r[1]*e_n[1]+e_r[2]*e_n[2];

          r_base[0]=e_n[0]*sprod;
          r_base[1]=e_n[1]*sprod;
          r_base[2]=e_n[2]*sprod;

	  r_sin[0]=e_n[1]*e_r[2]-e_n[2]*e_r[1];
	  r_sin[1]=e_n[2]*e_r[0]-e_n[0]*e_r[2];
	  r_sin[2]=e_n[0]*e_r[1]-e_n[1]*e_r[0];

	  so3[0*3+2]=co*so3[0*3+2]+(1-co)*r_base[0]+si*r_sin[0];
	  so3[1*3+2]=co*so3[1*3+2]+(1-co)*r_base[1]+si*r_sin[1];
	  so3[2*3+2]=co*so3[2*3+2]+(1-co)*r_base[2]+si*r_sin[2];

	  /* XXX This is just a ugly hack to guarantee 
             multiple turn_round_axis() calls won't build up big
	     numerical error. Could improve speed by a factor 2
	     if I implemented the correction code from do_turn()
             in turn_round_axis().
          */
	 /*do_turn(so3, 0,0);*/
	}
#line 690 "SO3.c"
    }
    XSRETURN(1);
}


XS(XS_Math__SO3_translate_vectors); /* prototype to pass -Wmissing-prototypes */
XS(XS_Math__SO3_translate_vectors)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 613 "SO3.xs"
	if(   items<1
           || SvTYPE(SvRV(ST(0)))!=SVt_PVMG)

	{
	  croak(croak_translate);
	}
	else
	{
	  int i;
	  Math__SO3 so3;
	  double x,y,z, *vec;

	  so3=(Math__SO3)(SvPV(SvRV(ST(0)), PL_na));

	  for(i=1;i<items;i++)
	    {
	      if(!SvPOK(ST(i)))
		{
		  croak(croak_translate);
		}
	    }
	  for(i=1;i<items;i++)
	    {
	      vec=(double *)SvPV(ST(i),PL_na);
	      x=vec[0];
	      y=vec[1];
	      z=vec[2];

	      vec[0]=so3[0*3+0]*x+so3[0*3+1]*y+so3[0*3+2]*z;
	      vec[1]=so3[1*3+0]*x+so3[1*3+1]*y+so3[1*3+2]*z;
	      vec[2]=so3[2*3+0]*x+so3[2*3+1]*y+so3[2*3+2]*z;
	    }
	}
#line 740 "SO3.c"
    }
    XSRETURN(1);
}


XS(XS_Math__SO3_inv_translate_vectors); /* prototype to pass -Wmissing-prototypes */
XS(XS_Math__SO3_inv_translate_vectors)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 657 "SO3.xs"
	if(   items<1
           || SvTYPE(SvRV(ST(0)))!=SVt_PVMG)

        {
	  croak(croak_inv_translate);
	}
	else
	{
	  int i;
	  Math__SO3 so3;
	  double x,y,z, *vec;

	  so3=(Math__SO3)(SvPV(SvRV(ST(0)), PL_na));

	  for(i=1;i<items;i++)
	    {
	      if(!SvPOK(ST(i)))
		{
		  croak(croak_inv_translate);
		}
	    }
	  for(i=1;i<items;i++)
	    {
	      vec=(double *)SvPV(ST(i),PL_na);
	      x=vec[0];
	      y=vec[1];
	      z=vec[2];
	      /* for orthogonal matrices, X^T = X^-1 */
	      vec[0]=so3[0*3+0]*x+so3[1*3+0]*y+so3[2*3+0]*z;
	      vec[1]=so3[0*3+1]*x+so3[1*3+1]*y+so3[2*3+1]*z;
	      vec[2]=so3[0*3+2]*x+so3[1*3+2]*y+so3[2*3+2]*z;
	    }
	}
#line 790 "SO3.c"
    }
    XSRETURN(1);
}


XS(XS_Math__SO3_turning_angle_and_dir); /* prototype to pass -Wmissing-prototypes */
XS(XS_Math__SO3_turning_angle_and_dir)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 715 "SO3.xs"
	{
          double angle, *dir, v2[3], v3[3], norm;
          char *cdir;

	  if(   (items!=1 && items != 2)
             || SvTYPE(SvRV(ST(0)))!=SVt_PVMG
             || 0==(cdir=alloca(1+3*sizeof(double))))
          {
             croak(croak_turning_angle_and_dir);
          }
          else
	  {
	    Math__SO3 so3;
            so3=(Math__SO3)(SvPV(SvRV(ST(0)), PL_na));
            cdir[3*sizeof(double)]=0;
            dir=(double *)cdir;

            angle=my_acos(0.5*(so3[0*3+0]+so3[1*3+1]+so3[2*3+2]-1));
            if(angle==M_PI || angle==-M_PI)
            {
             /* first, try (1,0,0)^T */

             v2[0]=so3[0*3+0];
             v2[1]=so3[1*3+0];
             v2[2]=so3[2*3+0];

             dir[0]=v2[0]+1;
             dir[1]=v2[1];
             dir[2]=v2[2];

             norm=sqrt(dir[0]*dir[0]+dir[1]*dir[1]+dir[2]*dir[2]);

             if(norm<0.0001)
               {
                /* try (0,1,0)^T */
                v2[0]=so3[0*3+1];
                v2[1]=so3[1*3+1];
                v2[2]=so3[2*3+1];

                dir[0]=v2[0];
                dir[1]=v2[1]+1;
                dir[2]=v2[2];

                norm=sqrt(dir[0]*dir[0]+dir[1]*dir[1]+dir[2]*dir[2]);
               }

             if(norm<0.0001)
               {
                /* lot of bad luck: (x,y,0)-plane "nearly" perpendicular to
                   turning direction. Now we simply could take z-direction,
                   but maybe this is a somewhat bad estimate; so, 
                   we play the same game once again with the (1,0,1) vector.
                 */

                /* try (0,1,0)^T */
                v2[0]=so3[0*3+0]+so3[0*3+2];
                v2[1]=so3[1*3+0]+so3[1*3+2];
                v2[2]=so3[2*3+0]+so3[2*3+2];

                dir[0]=v2[0]+1;
                dir[1]=v2[1];
                dir[2]=v2[2]+1;

                norm=sqrt(dir[0]*dir[0]+dir[1]*dir[1]+dir[2]*dir[2]);
               }


             dir[0]/=norm;
             dir[1]/=norm;
             dir[2]/=norm;
            }
            else
            {

              v2[0]=so3[0*3+0];
              v2[1]=so3[1*3+0];
              v2[2]=so3[2*3+0];

              v3[0]=so3[0*3+0]*v2[0]+so3[0*3+1]*v2[1]+so3[0*3+2]*v2[2];
  	      v3[1]=so3[1*3+0]*v2[0]+so3[1*3+1]*v2[1]+so3[1*3+2]*v2[2];
  	      v3[2]=so3[2*3+0]*v2[0]+so3[2*3+1]*v2[1]+so3[2*3+2]*v2[2];

              dir[0]=v3[1]*v2[2]-v3[2]*v2[1];
              dir[1]=v3[2]*(v2[0]-1)-(v3[0]-1)*v2[2];
              dir[2]=(v3[0]-1)*v2[1]-v3[1]*(v2[0]-1);

              norm=sqrt(dir[0]*dir[0]+dir[1]*dir[1]+dir[2]*dir[2]);
              if(norm<0.0001) 
              {
               /* "too close" -- gives numeric roundoff errors; 
                  redo with y vec */

                v2[0]=so3[0*3+1];
                v2[1]=so3[1*3+1];
                v2[2]=so3[2*3+1];

              v3[0]=so3[0*3+0]*v2[0]+so3[0*3+1]*v2[1]+so3[0*3+2]*v2[2];
    	      v3[1]=so3[1*3+0]*v2[0]+so3[1*3+1]*v2[1]+so3[1*3+2]*v2[2];
    	      v3[2]=so3[2*3+0]*v2[0]+so3[2*3+1]*v2[1]+so3[2*3+2]*v2[2];

                dir[0]=(v3[1]-1)*v2[2]-v3[2]*(v2[1]-1);
                dir[1]=v3[2]*v2[0]-v3[0]*v2[2];
                dir[2]=v3[0]*(v2[1]-1)-(v3[1]-1)*v2[0];

                norm=sqrt(dir[0]*dir[0]+dir[1]*dir[1]+dir[2]*dir[2]);
              }

              if(norm<0.0001) /* can only happen for identity. */
              {
               dir[0]=0;
               dir[0]=0;
               dir[0]=1;
              }
              else
              {
                dir[0]/=norm;
                dir[1]/=norm;
                dir[2]/=norm;
              }
            }  
            EXTEND(sp,2);
            if(items==2)
            {
             char *angle_spec;

             angle_spec=(char *)SvPV(ST(1), PL_na);
             if(angle_spec[0]=='d')
               {
                angle*=180/M_PI;
               }
             else if(angle_spec[0]!='r' && angle_spec[0]!=0)
               {
                croak(croak_turning_angle_and_dir);
               }
            }
            PUSHs(sv_2mortal(newSVnv(angle)));
            PUSHs(sv_2mortal(newSVpv(cdir,3*sizeof(double))));
	  }
        }
#line 948 "SO3.c"
	PUTBACK;
	return;
    }
}


XS(XS_Math__SO3_euler_angles_zxz); /* prototype to pass -Wmissing-prototypes */
XS(XS_Math__SO3_euler_angles_zxz)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 882 "SO3.xs"
         {
	  if(   (items!=1 && items!=2)
             || SvTYPE(SvRV(ST(0)))!=SVt_PVMG)
          {
             croak(croak_euler_angles_zxz);
          }
          else
          {
            int i;
            double phi, theta, psi, cos_theta, sin_theta, cos_psi, sin_psi, sin_phi, cos_phi;
            Math__SO3 so3;

            so3=(double *)(SvPV(SvRV(ST(0)),PL_na));
	    cos_theta=so3[2*3+2];
            theta=my_acos(cos_theta);
            sin_theta=sin(theta);

            if(sin_theta==0)
            {
	     psi=sin_psi=0; cos_psi=1;

             /* note that cos_psi=1, cos_theta=+-1, sin_psi=0 here; looking close reveals that
                the [0][0] element is just cos_phi, and [0][1] element is sin_phi */

             sin_phi=so3[0*3+1];
             cos_phi=so3[0*3+0];

             phi=atan2(sin_phi, cos_phi);
            }
            else
            {
	     sin_psi=so3[0*3+2]/sin_theta;
	     cos_psi=so3[1*3+2]/sin_theta;
             psi=atan2(sin_psi, cos_psi);

             sin_phi=so3[2*3+0]/sin_theta;
             cos_phi=-so3[2*3+1]/sin_theta;

             phi=atan2(sin_phi, cos_phi);
            }

            if(phi<0)phi+=2*M_PI;
            if(psi<0)psi+=2*M_PI;

            if(items==2)
            {
             char *angle_spec;

             angle_spec=(char *)SvPV(ST(1), PL_na);
             if(angle_spec[0]=='d')
               {
                phi*=180/M_PI;
                theta*=180/M_PI;
                psi*=180/M_PI;
               }
             else if(angle_spec[0]!='r' && angle_spec[0]!=0)
               {
                croak(croak_euler_angles_zxz);
               }
            }

            EXTEND(sp,3);
            PUSHs(sv_2mortal(newSVnv(phi)));
            PUSHs(sv_2mortal(newSVnv(theta)));
            PUSHs(sv_2mortal(newSVnv(psi)));
          }
         }
#line 1035 "SO3.c"
	PUTBACK;
	return;
    }
}


XS(XS_Math__SO3_euler_angles_yxz); /* prototype to pass -Wmissing-prototypes */
XS(XS_Math__SO3_euler_angles_yxz)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 986 "SO3.xs"
	{
          int i;
          double heading, pitch, roll, cos_heading, cos_pitch, cos_roll, sin_heading, sin_pitch, sin_roll;
          Math__SO3 so3;

	  if(   (items!=1 && items!=2)
             || SvTYPE(SvRV(ST(0)))!=SVt_PVMG)
          {
             croak(croak_euler_angles_zxz);
          }
          else
          {
            so3=(double *)(SvPV(SvRV(ST(0)),PL_na));

	    cos_pitch=sqrt(so3[0*3+2]*so3[0*3+2]+so3[2*3+2]*so3[2*3+2]); /* abs cos p */
            pitch=my_acos(cos_pitch);
            sin_pitch=so3[1*3+2];
            if(sin_pitch<0)pitch=-pitch;

            if(cos_pitch==0)
	    {
	     heading=0;

             sin_roll=so3[0*3+2];
             cos_roll=so3[0*3+0];

             roll=atan2(sin_roll, cos_roll);
            }
            else
            {
             sin_heading=-so3[1*3+0]/cos_pitch;
             cos_heading=so3[1*3+1]/cos_pitch;

             sin_roll=-so3[0*3+2]/cos_pitch;
             cos_roll=so3[2*3+2]/cos_pitch;

             heading=atan2(sin_heading, cos_heading);
             roll=atan2(sin_roll, cos_roll);
            }

            if(roll<0)roll+=2*M_PI;
            if(heading<0)heading+=2*M_PI;

            if(items==2)
            {
             char *angle_spec;

             angle_spec=(char *)SvPV(ST(1), PL_na);
             if(angle_spec[0]=='d')
               {
                heading*=180/M_PI;
                pitch*=180/M_PI;
                roll*=180/M_PI;
               }
             else if(angle_spec[0]!='r' && angle_spec[0]!=0)
               {
                croak(croak_euler_angles_zxz);
               }
            }

            EXTEND(sp,3);
            PUSHs(sv_2mortal(newSVnv(heading)));
            PUSHs(sv_2mortal(newSVnv(pitch)));
            PUSHs(sv_2mortal(newSVnv(roll)));
          }
        }
#line 1121 "SO3.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Math__SO3); /* prototype to pass -Wmissing-prototypes */
XS(boot_Math__SO3)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        (void)newXS("Math::SO3::invert", XS_Math__SO3_invert, file);
        (void)newXS("Math::SO3::turn", XS_Math__SO3_turn, file);
        (void)newXS("Math::SO3::combine", XS_Math__SO3_combine, file);
        (void)newXS("Math::SO3::turn_round_axis", XS_Math__SO3_turn_round_axis, file);
        (void)newXS("Math::SO3::translate_vectors", XS_Math__SO3_translate_vectors, file);
        (void)newXS("Math::SO3::inv_translate_vectors", XS_Math__SO3_inv_translate_vectors, file);
        (void)newXS("Math::SO3::turning_angle_and_dir", XS_Math__SO3_turning_angle_and_dir, file);
        (void)newXS("Math::SO3::euler_angles_zxz", XS_Math__SO3_euler_angles_zxz, file);
        (void)newXS("Math::SO3::euler_angles_yxz", XS_Math__SO3_euler_angles_yxz, file);
#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

